--- old/usr/src/uts/intel/os/fpu.c	Wed Apr 12 20:33:33 2023
+++ new/usr/src/uts/intel/os/fpu.c	Wed Apr 12 20:33:33 2023
@@ -1523,4 +1977,1315 @@
 		}
 		curthread->t_lwp->lwp_pcb.pcb_fpu.fpu_flags &= ~f;
 	}
+}
+
+/*
+ * Fill in FPU information that is required by exec.
+ */
+void
+fpu_auxv_info(int *typep, size_t *lenp)
+{
+	*typep = fp_elf;
+	switch (fp_save_mech) {
+	case FP_FXSAVE:
+		*lenp = sizeof (struct fxsave_state);
+		break;
+	case FP_XSAVE:
+		*lenp = cpuid_get_xsave_size();
+		break;
+	default:
+		*lenp = 0;
+		break;
+	}
+}
+
+/*
+ * This function exists to transform an xsave_state into an fxsave_state. The
+ * way that we have to do this is nuanced. We assume that callers have already
+ * handled FPU_EN and thus we only need to consider the xsave_state and its
+ * component vector itself. This results in the following cases that we need to
+ * consider:
+ *
+ *   o Neither the x87 / XMM state bits are set. We use the hardware default and
+ *     need to ensure to copy the xsave header.
+ *   o Both x87 / XMM state bits are set. We can copy everything.
+ *   o Only the x87 bit is set. We need to copy the x87 state but make the XMM
+ *     state be in the initial case.
+ *   o Only the XMM bit is set. The reverse of the above case.
+ *
+ * The illumos and hardware defaults in 'sse_initial' and 'avx_initial' are
+ * generally the same; however, the default floating point control word is
+ * different.
+ *
+ * Finally, we have the complication of the MXCSR and MCXSR_MASK registers.
+ * Because we are using xsave and xsaveopt in the kernel right now and not
+ * xsavec, the hardware may write out the MXCSR and MXCSR_MASK registers if the
+ * XFEATURE_AVX bit is set. Therefore if we don't have the XMM bit set but AVX
+ * is set, we must also come back and copy out the MXCSR register. Sorry, we
+ * don't make the rules.
+ */
+static void
+fpu_xsave_to_fxsave(const struct xsave_state *xsave, struct fxsave_state *fx)
+{
+	const uint64_t comps = xsave->xs_header.xsh_xstate_bv;
+
+	switch (comps & (XFEATURE_LEGACY_FP | XFEATURE_SSE)) {
+	case XFEATURE_LEGACY_FP | XFEATURE_SSE:
+		bcopy(xsave, fx, sizeof (*fx));
+		return;
+	case XFEATURE_LEGACY_FP:
+		bcopy(xsave, fx, offsetof(struct fxsave_state, fx_xmm));
+		fx->fx_mxcsr = SSE_MXCSR_INIT;
+		fx->fx_mxcsr_mask = 0;
+		break;
+	case XFEATURE_SSE:
+		bcopy(&sse_initial, fx, offsetof(struct fxsave_state,
+		    fx_mxcsr));
+
+		fx->fx_fcw = FPU_CW_INIT_HW;
+		fx->fx_mxcsr = xsave->xs_fxsave.fx_mxcsr;
+		fx->fx_mxcsr_mask = xsave->xs_fxsave.fx_mxcsr_mask;
+		bcopy(xsave->xs_fxsave.fx_xmm, fx->fx_xmm, sizeof (fx->fx_xmm));
+		break;
+	default:
+		bcopy(&sse_initial, fx, sizeof (*fx));
+		fx->fx_fcw = FPU_CW_INIT_HW;
+		break;
+	}
+
+	/*
+	 * Account for the AVX causing MXCSR to be valid.
+	 */
+	if ((xsave->xs_header.xsh_xstate_bv & XFEATURE_AVX) != 0 &&
+	    (xsave->xs_header.xsh_xstate_bv & XFEATURE_SSE) == 0) {
+		fx->fx_mxcsr = xsave->xs_fxsave.fx_mxcsr;
+		fx->fx_mxcsr_mask = xsave->xs_fxsave.fx_mxcsr_mask;
+	}
+}
+
+/*
+ * This function is designed to answer the question of are we using any xsave
+ * family of instructions in context switch and therefore we have this state.
+ * This should still remain true if we are using xsavec or xsaves in the kernel
+ * in the future.
+ */
+boolean_t
+fpu_xsave_enabled(void)
+{
+	return (fp_save_mech == FP_XSAVE);
+}
+
+/*
+ * The following structure is used to track and manage the programmatic
+ * construction of /proc and signal stack spilling of xsave information. All
+ * known xsave types that the kernel supports must be included here.
+ */
+typedef struct xsave_proc_info {
+	/*
+	 * This matches the /proc xregs type that this data represents. This s
+	 * used for /proc only.
+	 */
+	uint32_t xi_type;
+	/*
+	 * This indicates the size of the /proc data that we're operating on.
+	 * This is only used for /proc.
+	 */
+	size_t	xi_size;
+	/*
+	 * This indicates the alignment that we want to have for the member when
+	 * we're writing out. This is not used when setting data. This is only
+	 * used for /proc.
+	 */
+	size_t	xi_align;
+	/*
+	 * This indicates whether this member must always be considered or not.
+	 * This is used in both /proc and context/signal handling.
+	 */
+	bool	xi_always;
+	/*
+	 * This contains the corresponding bits in the xsave bit vector that
+	 * corresponds to this entry. This is used for both /proc and
+	 * context/signal handling.
+	 */
+	uint64_t xi_bits;
+	/*
+	 * The xi_fill function pointer is used to write out the /proc regset
+	 * data (e.g. when a user reads xregs). This is only used for the /proc
+	 * handling. The xi_valid function pointer is used instead to validate a
+	 * given set of data that we've read in, while the xi_set pointer is
+	 * used to actually transform the data in the underlying fpu save area.
+	 */
+	void	(*xi_fill)(const fpu_ctx_t *, const struct xsave_proc_info *,
+	    void *);
+	bool	(*xi_valid)(model_t, const void *);
+	void	(*xi_set)(fpu_ctx_t *, const struct xsave_proc_info *,
+	    uint64_t, const void *);
+	/*
+	 * The xi_signal_in and xi_signal_out function pointers are used for
+	 * extended context and signal handling information. They are used when
+	 * reading in data from a ucontex_t and writing it out respectively.
+	 * These are only used for context/signal handling.
+	 */
+	int	(*xi_signal_in)(const struct xsave_proc_info *,
+	    const ucontext_t *, const uc_xsave_t *, void *, uintptr_t *,
+	    const uintptr_t);
+	int	(*xi_signal_out)(const struct xsave_proc_info *, fpu_copyout_f,
+	    uc_xsave_t *, const void *fpup, uintptr_t);
+} xsave_proc_info_t;
+
+static bool
+fpu_proc_xregs_initial_state(const fpu_ctx_t *fpu, uint64_t feats)
+{
+	if ((fpu->fpu_flags & (FPU_EN | FPU_VALID)) == 0) {
+		return (B_TRUE);
+	}
+
+	return ((fpu->fpu_regs.kfpu_u.kfpu_xs->xs_header.xsh_xstate_bv &
+	    feats) == 0);
+}
+
+static void
+fpu_proc_xregs_xcr_fill(const fpu_ctx_t *fpu, const xsave_proc_info_t *info,
+    void *datap)
+{
+	prxregset_xcr_t *xcr = datap;
+
+	xcr->prx_xcr_xcr0 = xsave_bv_all;
+}
+
+/*
+ * Unlike other instruction portions, we treat the xsave header and the legacy
+ * XMM section together as both are somewhat tied at the instruction hip. Unlike
+ * the latter values, the initial state here is not quite the same.
+ */
+static void
+fpu_proc_xregs_xsave_fill(const fpu_ctx_t *fpu, const xsave_proc_info_t *info,
+    void *datap)
+{
+	prxregset_xsave_t *prxsave = datap;
+	const struct xsave_state *xsave = fpu->fpu_regs.kfpu_u.kfpu_xs;
+	size_t hdr_off;
+
+	/*
+	 * In the x87/XMM case, the no device vs. initial state is different
+	 * because the initial state case still wants us to copy the real xsave
+	 * header. It's also worth calling out that the actual illumos default
+	 * fxsave state is not the same as what Intel documents. The main
+	 * difference is in what the x87 FPU control word is. This results in
+	 * the following different cases that we need to think about:
+	 *
+	 *   o FPU_EN is not set. So we use the illumos default.
+	 */
+	if ((fpu->fpu_flags & FPU_EN) == 0) {
+		bcopy(&avx_initial, prxsave, sizeof (*prxsave));
+		return;
+	}
+
+	/*
+	 * Convert all the fxsave region while taking into account the validity
+	 * of the xsave bits. The prxregset_xsave_t structure is identical in
+	 * the first 512-bits to the prxsave structure.
+	 */
+	fpu_xsave_to_fxsave(xsave, (struct fxsave_state *)prxsave);
+
+	/*
+	 * Now that we've dealt with the x87 and XMM state, take care of the
+	 * header.
+	 */
+	hdr_off = offsetof(prxregset_xsave_t, prx_xsh_xstate_bv);
+	bcopy((const void *)((uintptr_t)xsave + hdr_off),
+	    (void *)((uintptr_t)prxsave + hdr_off),
+	    sizeof (struct xsave_header));
+}
+
+static void
+fpu_proc_xregs_std_fill(const fpu_ctx_t *fpu, const xsave_proc_info_t *info,
+    void *datap)
+{
+	if (!fpu_proc_xregs_initial_state(fpu, info->xi_bits)) {
+		size_t size, off;
+		const void *xsave_off;
+
+		cpuid_get_xsave_info(info->xi_bits, &size, &off);
+		ASSERT3U(size, ==, info->xi_size);
+		xsave_off = (void *)((uintptr_t)fpu->fpu_regs.kfpu_u.kfpu_xs +
+		    off);
+		bcopy(xsave_off, datap, info->xi_size);
+	}
+}
+
+/*
+ * Users are not allowed to actually set the xcr information this way. However,
+ * to make it easier for someone to just do a read, modify, write, of the xregs
+ * data, if it is identical, then we will accept it (and do nothing).
+ */
+static bool
+fpu_proc_xregs_xcr_valid(model_t model, const void *datap)
+{
+	const prxregset_xcr_t *xcr = datap;
+
+	return (xcr->prx_xcr_xcr0 == xsave_bv_all && xcr->prx_xcr_xfd == 0 &&
+	    xcr->prx_xcr_pad[0] == 0 && xcr->prx_xcr_pad[1] == 0);
+}
+
+/*
+ * To match traditional /proc semantics, we do not error if reserved bits of
+ * MXCSR are set, they will be masked off when writing data. We do not allow
+ * someone to indicate that they are asking for compressed xsave data, hence the
+ * check that prx_xsh_comp_bv is zero. Finally, we will check that each
+ * component that was indicated in the xstate_bv is present as another item as
+ * part of the broader validation path.
+ */
+static bool
+fpu_proc_xregs_xsave_valid(model_t model, const void *datap)
+{
+	const prxregset_xsave_t *xsave = datap;
+	uint64_t rsvd[6] = { 0 };
+
+	if (bcmp(rsvd, xsave->prx_xsh_reserved, sizeof (rsvd)) != 0 ||
+	    xsave->prx_xsh_xcomp_bv != 0) {
+		return (false);
+	}
+
+	if ((xsave->prx_xsh_xstate_bv & ~xsave_bv_all) != 0) {
+		return (false);
+	}
+
+	return (true);
+}
+
+/*
+ * The YMM, ZMM, and Hi-ZMM registers are all valid when in an LP64 environment
+ * on x86; however, when operating in ILP32, subsets are reserved. We basically
+ * require that all reserved portions are set to zero as our way to accept them.
+ */
+static bool
+fpu_proc_xregs_ymm_valid(model_t model, const void *datap)
+{
+	upad128_t ymm_zero[8];
+	const prxregset_ymm_t *ymm = datap;
+
+	if (model == DATAMODEL_LP64) {
+		return (true);
+	}
+
+	bzero(&ymm_zero, sizeof (ymm_zero));
+	return (bcmp(&ymm->prx_ymm[8], &ymm_zero, sizeof (ymm_zero)) == 0);
+}
+
+static bool
+fpu_proc_xregs_zmm_valid(model_t model, const void *datap)
+{
+	upad256_t zmm_zero[8];
+	const prxregset_zmm_t *zmm = datap;
+
+	if (model == DATAMODEL_LP64) {
+		return (true);
+	}
+
+	bzero(&zmm_zero, sizeof (zmm_zero));
+	return (bcmp(&zmm->prx_zmm[8], &zmm_zero, sizeof (zmm_zero)) == 0);
+}
+
+static bool
+fpu_proc_xregs_hi_zmm_valid(model_t model, const void *datap)
+{
+	prxregset_hi_zmm_t hi_zmm_zero;
+	const prxregset_hi_zmm_t *hi_zmm = datap;
+
+	if (model == DATAMODEL_LP64) {
+		return (true);
+	}
+
+	bzero(&hi_zmm_zero, sizeof (hi_zmm_zero));
+	return (bcmp(hi_zmm, &hi_zmm_zero, sizeof (hi_zmm_zero)) == 0);
+}
+
+/*
+ * The xsave state consists of the first 512 byes of the XMM state and then the
+ * xsave header itself. Because of the xsave header, this structure is marked
+ * with xi_always, so we must always process and consider it.
+ *
+ * Semantically if either of the bits around SSE / x87 is set, then we will copy
+ * the entire thing. This may mean that we end up copying a region that is not
+ * valid into the save area; however, that should be OK as we still have the
+ * specific bit flags that indicate what we should consider or not.
+ *
+ * There is one additional wrinkle we need to consider and honor here. The CPU
+ * will load the MXCSR values if the AVX bit is set in an xrstor regardless of
+ * anything else. So if if this is set and we do not have a valid x87/XMM bits
+ * set then we will set the MXCSR to its default state in case the processor
+ * tries to load it. For reference see:
+ *
+ *   o Intel SDM Volume 1: 13.8.1 Standard Form of XRSTOR
+ *   o AMD64 Volume 2: Section 11.5.9 MXCSR State Management
+ *
+ * Note, the behavior around this changes depending on whether using the
+ * compressed xrstor or not. We are not, but it's worth being aware of. We do
+ * not worry about MXCSR_MASK because the instructions ignore it.
+ */
+static void
+fpu_proc_xregs_xsave_set(fpu_ctx_t *fpu, const xsave_proc_info_t *info,
+    uint64_t xsave_bv, const void *datap)
+{
+	const struct xsave_state *xs = datap;
+
+	if ((xsave_bv & info->xi_bits) != 0) {
+		bcopy(&xs->xs_fxsave, &fpu->fpu_regs.kfpu_u.kfpu_xs->xs_fxsave,
+		    sizeof (struct fxsave_state));
+	} else if ((xsave_bv & XFEATURE_AVX) != 0) {
+		fpu->fpu_regs.kfpu_u.kfpu_xs->xs_fxsave.fx_mxcsr =
+		    SSE_MXCSR_INIT;
+	}
+
+	bcopy(&xs->xs_header, &fpu->fpu_regs.kfpu_u.kfpu_xs->xs_header,
+	    sizeof (struct xsave_header));
+	fpu->fpu_regs.kfpu_u.kfpu_xs->xs_fxsave.fx_mxcsr &= sse_mxcsr_mask;
+}
+
+static void
+fpu_proc_xregs_std_set(fpu_ctx_t *fpu, const xsave_proc_info_t *info,
+    uint64_t xsave_bv, const void *datap)
+{
+	size_t size, off;
+	void *xsave_off;
+
+	cpuid_get_xsave_info(info->xi_bits, &size, &off);
+	xsave_off = (void *)((uintptr_t)fpu->fpu_regs.kfpu_u.kfpu_xs +
+	    off);
+	bcopy(datap, xsave_off, size);
+}
+
+/*
+ * Dealing with XMM data is a little more annoying here. If UC_FPU is set, it
+ * also contains a copy of the XMM region. That must take priority over anything
+ * we have here. In the copyout code we do not set the XMM bits here as
+ * something to copy, therefore if they are set, we currently treat that as an
+ * error.
+ *
+ * The system has always gone through and cleaned up the reserved bits in the
+ * fxsave state when someone calls setcontext(). Therefore we need to do the
+ * same thing which is why you see the masking of the mxcsr below.
+ *
+ * Finally, there is one last wrinkle here that we need to consider. The
+ * fpregset_t has historically had two private words that are used to convey the
+ * status which cache the status/exception information. Therefore, we well...
+ * cheat. Intel has left bytes 464 (0x1d0) through 511 (0x1ff) available for us
+ * to do what we want. So we will pass this through that for the moment to help
+ * us pass this state around without too much extra allocation.
+ */
+static int
+fpu_signal_copyin_xmm(const xsave_proc_info_t *info, const ucontext_t *kuc,
+    const uc_xsave_t *ucx, void *fpup, uintptr_t *udatap,
+    const uintptr_t max_udata)
+{
+	struct xsave_state *xsave = fpup;
+
+	if ((ucx->ucx_bv & info->xi_bits) != 0) {
+		return (EINVAL);
+	}
+
+	if ((kuc->uc_flags & UC_FPU) != 0) {
+		bcopy(&kuc->uc_mcontext.fpregs, &xsave->xs_fxsave,
+		    sizeof (struct fxsave_state));
+		xsave->xs_fxsave.__fx_ign2[3]._l[0] =
+		    kuc->uc_mcontext.fpregs.fp_reg_set.fpchip_state.status;
+		xsave->xs_fxsave.__fx_ign2[3]._l[1] =
+		    kuc->uc_mcontext.fpregs.fp_reg_set.fpchip_state.xstatus;
+		xsave->xs_fxsave.fx_mxcsr &= sse_mxcsr_mask;
+		xsave->xs_header.xsh_xstate_bv |= info->xi_bits;
+	}
+
+	return (0);
+}
+
+static int
+fpu_signal_copyin_std(const xsave_proc_info_t *info, const ucontext_t *kuc,
+    const uc_xsave_t *ucx, void *fpup, uintptr_t *udatap,
+    const uintptr_t max_udata)
+{
+	size_t len, xsave_off;
+	void *copy_to;
+	struct xsave_state *xsave = fpup;
+
+	cpuid_get_xsave_info(info->xi_bits, &len, &xsave_off);
+	if (*udatap + len > max_udata) {
+		return (EOVERFLOW);
+	}
+
+	copy_to = (void *)((uintptr_t)fpup + xsave_off);
+	if (ddi_copyin((void *)*udatap, copy_to, len, 0) != 0) {
+		return (EFAULT);
+	}
+
+	xsave->xs_header.xsh_xstate_bv |= info->xi_bits;
+	*udatap = *udatap + len;
+
+	return (0);
+}
+
+static int
+fpu_signal_copyout_std(const xsave_proc_info_t *info, fpu_copyout_f copyfunc,
+    uc_xsave_t *ucx, const void *fpup, uintptr_t udatap)
+{
+	size_t len, xsave_off;
+	const void *copy_from;
+	void *copy_to;
+	int ret;
+
+	cpuid_get_xsave_info(info->xi_bits, &len, &xsave_off);
+	copy_from = (void *)(uintptr_t)fpup + xsave_off;
+	copy_to = (void *)(udatap + ucx->ucx_len);
+
+	ret = copyfunc(copy_from, copy_to, len);
+	if (ret != 0) {
+		return (ret);
+	}
+
+	ucx->ucx_len += len;
+	ucx->ucx_bv |= info->xi_bits;
+	return (0);
+}
+
+/*
+ * This table contains information about the extended FPU states and synthetic
+ * information we create for /proc, the ucontext_t, and signal handling. The
+ * definition of the xsave_proc_info_t describes how each member is used.
+ *
+ * In general, this table is expected to be in the order of the xsave data
+ * structure itself. Synthetic elements that we create can go anywhere and new
+ * ones should be inserted at the end. This structure is walked in order to
+ * produce the /proc and signal handling logic, so changing the order is
+ * meaningful for those and probably should not be done lightly.
+ */
+static const xsave_proc_info_t fpu_xsave_info[] = { {
+	.xi_type = PRX_INFO_XCR,
+	.xi_size = sizeof (prxregset_xcr_t),
+	.xi_align = alignof (prxregset_xcr_t),
+	.xi_always = true,
+	.xi_bits = 0,
+	.xi_fill = fpu_proc_xregs_xcr_fill,
+	.xi_valid = fpu_proc_xregs_xcr_valid
+}, {
+	/*
+	 * The XSAVE entry covers both the xsave header and the %xmm registers.
+	 * Note, there is no signal copyout information for the %xmm registers
+	 * because it is expected that that data is already in the fpregset_t.
+	 */
+	.xi_type = PRX_INFO_XSAVE,
+	.xi_size = sizeof (prxregset_xsave_t),
+	.xi_align = FPU_ALIGN_XMM,
+	.xi_always = true,
+	.xi_bits = XFEATURE_LEGACY_FP | XFEATURE_SSE,
+	.xi_fill = fpu_proc_xregs_xsave_fill,
+	.xi_set = fpu_proc_xregs_xsave_set,
+	.xi_valid = fpu_proc_xregs_xsave_valid,
+	.xi_signal_in = fpu_signal_copyin_xmm
+}, {
+	.xi_type = PRX_INFO_YMM,
+	.xi_size = sizeof (prxregset_ymm_t),
+	.xi_align = FPU_ALIGN_YMM,
+	.xi_always = false,
+	.xi_bits = XFEATURE_AVX,
+	.xi_fill = fpu_proc_xregs_std_fill,
+	.xi_set = fpu_proc_xregs_std_set,
+	.xi_signal_in = fpu_signal_copyin_std,
+	.xi_valid = fpu_proc_xregs_ymm_valid,
+	.xi_signal_out = fpu_signal_copyout_std
+}, {
+	/*
+	 * There is no /proc validation function for the mask registers because
+	 * they are the same in ILP32 / LP64 and there is nothing for us to
+	 * actually validate.
+	 */
+	.xi_type = PRX_INFO_OPMASK,
+	.xi_size = sizeof (prxregset_opmask_t),
+	.xi_align = alignof (prxregset_opmask_t),
+	.xi_always = false,
+	.xi_bits = XFEATURE_AVX512_OPMASK,
+	.xi_fill = fpu_proc_xregs_std_fill,
+	.xi_set = fpu_proc_xregs_std_set,
+	.xi_signal_in = fpu_signal_copyin_std,
+	.xi_signal_out = fpu_signal_copyout_std
+}, {
+	.xi_type = PRX_INFO_ZMM,
+	.xi_size = sizeof (prxregset_zmm_t),
+	.xi_align = FPU_ALIGN_ZMM,
+	.xi_always = false,
+	.xi_bits = XFEATURE_AVX512_ZMM,
+	.xi_fill = fpu_proc_xregs_std_fill,
+	.xi_set = fpu_proc_xregs_std_set,
+	.xi_valid = fpu_proc_xregs_zmm_valid,
+	.xi_signal_in = fpu_signal_copyin_std,
+	.xi_signal_out = fpu_signal_copyout_std
+}, {
+	.xi_type = PRX_INFO_HI_ZMM,
+	.xi_size = sizeof (prxregset_hi_zmm_t),
+	.xi_align = FPU_ALIGN_ZMM,
+	.xi_always = false,
+	.xi_bits = XFEATURE_AVX512_HI_ZMM,
+	.xi_fill = fpu_proc_xregs_std_fill,
+	.xi_set = fpu_proc_xregs_std_set,
+	.xi_valid = fpu_proc_xregs_hi_zmm_valid,
+	.xi_signal_in = fpu_signal_copyin_std,
+	.xi_signal_out = fpu_signal_copyout_std
+} };
+
+static bool
+fpu_proc_xregs_include(const xsave_proc_info_t *infop)
+{
+	return (infop->xi_always || (xsave_bv_all & infop->xi_bits) != 0);
+}
+
+void
+fpu_proc_xregs_info(struct proc *p __unused, uint32_t *ninfop, uint32_t *sizep,
+    uint32_t *dstart)
+{
+	size_t ret = sizeof (prxregset_hdr_t);
+	uint32_t ninfo = 0;
+
+	ASSERT(fpu_xsave_enabled());
+
+	/*
+	 * Right now the set of flags that are enabled in the FPU is global.
+	 * That is, while the pcb's fcpu_ctx_t has the fpu_xsave_mask, the
+	 * actual things that might show up and we care about are all about what
+	 * is set up in %xcr0 which is stored in the global xsave_bv_all. If we
+	 * move to per-process FPU enablement which is likely to come with AMX,
+	 * then this will need the proc_t to look at, hence why we've set things
+	 * up with the unused variable above.
+	 *
+	 * We take two passes through the array. The first is just to count up
+	 * how many informational entries we need.
+	 */
+	for (size_t i = 0; i < ARRAY_SIZE(fpu_xsave_info); i++) {
+		if (!fpu_proc_xregs_include(&fpu_xsave_info[i]))
+			continue;
+		ninfo++;
+	}
+
+	ASSERT3U(ninfo, >, 0);
+	ret += sizeof (prxregset_info_t) * ninfo;
+
+	for (size_t i = 0; i < ARRAY_SIZE(fpu_xsave_info); i++) {
+		size_t curphase;
+		if (!fpu_proc_xregs_include(&fpu_xsave_info[i]))
+			continue;
+
+		curphase = ret % fpu_xsave_info[i].xi_align;
+		if (ret < fpu_xsave_info[i].xi_align) {
+			ret = fpu_xsave_info[i].xi_align;
+		} else if (curphase != 0) {
+			ret += curphase;
+		}
+
+		if (i == 0 && dstart != NULL) {
+			*dstart = ret;
+		}
+
+		ret += fpu_xsave_info[i].xi_size;
+	}
+
+	VERIFY3U(ret, <=, UINT32_MAX);
+	if (sizep != NULL) {
+		*sizep = ret;
+	}
+
+	if (ninfop != NULL) {
+		*ninfop = ninfo;
+	}
+}
+
+/*
+ * This function supports /proc. Because /proc does not have a process locked
+ * while processing a PCSXREG, so this tries to establish an upper bound that we
+ * will validate later in fpu_proc_xregs_set(). We basically say that if you
+ * take the maximum xsave size and add 1 KiB that is a good enough approximation
+ * for the maximum size.
+ */
+size_t
+fpu_proc_xregs_max_size(void)
+{
+	VERIFY(fpu_xsave_enabled());
+	return (cpuid_get_xsave_size() + 0x1000);
+}
+
+/*
+ * This functions supports /proc. In particular, it's meant to perform the
+ * following:
+ *
+ *  o Potentially save the current thread's registers.
+ *  o Write out the x86 xsave /proc xregs format data from the xsave data we
+ *    actually have. Note, this can be a little weird for cases where the FPU is
+ *    not actually enabled, which happens for system processes.
+ *    /proc let us read this state?
+ */
+void
+fpu_proc_xregs_get(struct _klwp *lwp, void *buf)
+{
+	uint32_t size, ninfo, curinfo, dstart;
+	fpu_ctx_t *fpu = &lwp->lwp_pcb.pcb_fpu;
+	prxregset_hdr_t *hdr = buf;
+
+	ASSERT(fpu_xsave_enabled());
+	fpu_proc_xregs_info(lwp->lwp_procp, &ninfo, &size, &dstart);
+
+	/*
+	 * Before we get going, defensively zero out all the data buffer so that
+	 * the rest of the fill functions can assume a specific base.
+	 */
+	bzero(buf, size);
+
+	kpreempt_disable();
+	if ((fpu->fpu_flags & (FPU_EN | FPU_VALID)) == FPU_EN) {
+		/*
+		 * This case suggests that thread in question doesn't have a
+		 * valid FPU save state which should only happen when it is on
+		 * CPU. If this is the case, we must ensure that we save the
+		 * current FPU state before proceeding. We also sanity check
+		 * several things here before doing this as using /proc on
+		 * yourself is always exciting. fp_save() will ensure that the
+		 * thread is flagged to go back to being an eager FPU before
+		 * returning back to userland.
+		 */
+		VERIFY3P(curthread, ==, lwptot(lwp));
+		VERIFY0(lwptot(lwp)->t_flag & T_KFPU);
+		fp_save(fpu);
+	}
+	kpreempt_enable();
+
+	hdr->pr_type = PR_TYPE_XSAVE;
+	hdr->pr_size = size;
+	hdr->pr_flags = hdr->pr_pad[0] = hdr->pr_pad[1] = hdr->pr_pad[2] =
+	    hdr->pr_pad[3] = 0;
+	hdr->pr_ninfo = ninfo;
+
+	curinfo = 0;
+	for (size_t i = 0; i < ARRAY_SIZE(fpu_xsave_info); i++) {
+		void *startp;
+		uint32_t phase;
+
+		if (!fpu_proc_xregs_include(&fpu_xsave_info[i]))
+			continue;
+
+		phase = dstart % fpu_xsave_info[i].xi_align;
+		if (dstart < fpu_xsave_info[i].xi_align) {
+			ASSERT3U(i, !=, 0);
+			dstart = fpu_xsave_info[i].xi_align;
+		} else if (phase != 0) {
+			ASSERT3U(i, !=, 0);
+			dstart += phase;
+		}
+
+		hdr->pr_info[curinfo].pri_type = fpu_xsave_info[i].xi_type;
+		hdr->pr_info[curinfo].pri_flags = 0;
+		hdr->pr_info[curinfo].pri_size = fpu_xsave_info[i].xi_size;
+		hdr->pr_info[curinfo].pri_offset = dstart;
+
+		startp = (void *)((uintptr_t)buf + dstart);
+		fpu_xsave_info[i].xi_fill(fpu, &fpu_xsave_info[i], startp);
+		dstart += fpu_xsave_info[i].xi_size;
+		ASSERT3U(curinfo, <=, ninfo);
+		curinfo++;
+	}
+}
+
+/*
+ * We have been asked to set the data in the FPU for a given thread. Our
+ * prmachdep code has already validated that the raw semantics of the data that
+ * we have are valid (that is the appropriate sizes, offsets, and flags). We now
+ * apply additional checking here:
+ *
+ *   o The xsave structure is present and only valid bits are set.
+ *   o If the xsave component bit-vector is set, we have the corresponding proc
+ *     info item.
+ *   o Read-only items are ignored if and only if they actually match what we
+ *     gave the user mostly as a courtesy to simplify things here.
+ *   o ILP32 processes which can't support many of the regions are allowed to
+ *     have the items here (as we likely gave them to them), but they must be
+ *     zero if they are set.
+ *
+ * We take a first pass through all the data, validating it makes sense for the
+ * FPU. Only after that point do we ensure that we have the FPU data in question
+ * and then we clobber all the FPU data. Part of the semantics of setting this
+ * is that we're setting the entire extended FPU.
+ */
+int
+fpu_proc_xregs_set(struct _klwp *lwp, void *buf)
+{
+	prxregset_hdr_t *prx = buf;
+	model_t model = lwp_getdatamodel(lwp);
+	uint64_t bv_found = 0;
+	const prxregset_xsave_t *xsave = NULL;
+	fpu_ctx_t *fpu = &lwp->lwp_pcb.pcb_fpu;
+
+	VERIFY(fpu_xsave_enabled());
+
+	/*
+	 * First, walk each note info header that we have from the user and
+	 * proceed to validate it. The prmachdep code has already validated that
+	 * the size, type, and offset information is valid, but it has not
+	 * validated the semantic contents of this or if someone is trying to
+	 * write something they shouldn't.
+	 *
+	 * While we walk this, we keep track of where the xsave header is. We
+	 * also track all of the bits that we have found along the way so we can
+	 * match up and ensure that everything that was set has a corresponding
+	 * bit in the xsave bitmap. If we have something in the xsave bitmap,
+	 * but not its corresponding data, then that is an error. However, we
+	 * allow folks to write data regions without the bit set in the xsave
+	 * data to make the read, modify, write process simpler.
+	 */
+	for (uint32_t i = 0; i < prx->pr_ninfo; i++) {
+		const prxregset_info_t *info = &prx->pr_info[i];
+		bool found = false;
+
+		for (size_t pt = 0; pt < ARRAY_SIZE(fpu_xsave_info); pt++) {
+			void *data;
+			if (info->pri_type != fpu_xsave_info[pt].xi_type)
+				continue;
+
+			found = true;
+			data = (void *)((uintptr_t)buf + info->pri_offset);
+			if (fpu_xsave_info[pt].xi_valid != NULL &&
+			    !fpu_xsave_info[pt].xi_valid(model, data)) {
+				return (EINVAL);
+			}
+
+			if (info->pri_type == PRX_INFO_XSAVE) {
+				xsave = data;
+			}
+			bv_found |= fpu_xsave_info[pt].xi_bits;
+			break;
+		}
+
+		if (!found) {
+			return (EINVAL);
+		}
+	}
+
+	/*
+	 * No xsave data, no dice.
+	 */
+	if (xsave == NULL) {
+		return (EINVAL);
+	}
+
+	/*
+	 * If anything is set in the xsave header that was not found as we
+	 * walked structures, then that is an error. The opposite is not true as
+	 * discussed above.
+	 */
+	if ((xsave->prx_xsh_xstate_bv & ~bv_found) != 0) {
+		return (EINVAL);
+	}
+
+	/*
+	 * At this point, we consider all the data actually valid. Now we must
+	 * set up this information in the save area. If this is our own lwp, we
+	 * must disable it first. Otherwise, we expect that it is already valid.
+	 * To try to sanitize this, we will defensively zero the entire region
+	 * as we are setting everything that will result in here.
+	 */
+	kpreempt_disable();
+	if ((fpu->fpu_flags & (FPU_EN | FPU_VALID)) == FPU_EN) {
+		/*
+		 * This case suggests that thread in question doesn't have a
+		 * valid FPU save state which should only happen when it is on
+		 * CPU. If this is the case, we explicitly disable the FPU, but
+		 * do not save it before proceeding. We also sanity check
+		 * several things here before doing this as using /proc on
+		 * yourself is always exciting. Unlike fp_save(), fp_free() does
+		 * not signal that an update is required, so we unconditionally
+		 * set that for all threads.
+		 */
+		VERIFY3P(curthread, ==, lwptot(lwp));
+		VERIFY0(lwptot(lwp)->t_flag & T_KFPU);
+		fp_free(fpu);
+	}
+	PCB_SET_UPDATE_FPU(&lwp->lwp_pcb);
+	bzero(lwp->lwp_pcb.pcb_fpu.fpu_regs.kfpu_u.kfpu_generic,
+	    cpuid_get_xsave_size());
+
+	for (uint32_t i = 0; i < prx->pr_ninfo; i++) {
+		const prxregset_info_t *info = &prx->pr_info[i];
+		bool found = false;
+
+		for (size_t pt = 0; pt < ARRAY_SIZE(fpu_xsave_info); pt++) {
+			const void *data;
+			if (info->pri_type != fpu_xsave_info[pt].xi_type)
+				continue;
+
+			/*
+			 * Check if we have a set function and if we should
+			 * include this. We may not if this is something like
+			 * PRX_INFO_XCR which is read-only.
+			 *
+			 * We may not include a given entry as it may not have
+			 * been set in the actual xsave state that we have been
+			 * asked to restore, in which case to not break the
+			 * xsaveopt logic, we must leave it in its initial
+			 * state, e.g. zeroed (generally). XMM data initial
+			 * state is not zeroed, but is marked with xi_always to
+			 * help account for this.
+			 */
+			found = true;
+			if (fpu_xsave_info[pt].xi_set == NULL)
+				break;
+			if (!fpu_xsave_info[pt].xi_always &&
+			    (xsave->prx_xsh_xstate_bv &
+			    fpu_xsave_info[pt].xi_bits) !=
+			    fpu_xsave_info[pt].xi_bits) {
+				break;
+			}
+
+			data = (void *)((uintptr_t)buf + info->pri_offset);
+			fpu_xsave_info[pt].xi_set(fpu, &fpu_xsave_info[pt],
+			    xsave->prx_xsh_xstate_bv, data);
+		}
+
+		VERIFY(found);
+	}
+	kpreempt_enable();
+
+	return (0);
+}
+
+/*
+ * To be included in the signal copyout logic we must have a copy function and
+ * the bit in question must be included. Note, we don't consult xi_always here
+ * as that is really part of what is always present for xsave logic and
+ * therefore isn't really pertinent here because of our custom format. See the
+ * big theory statement for more info.
+ */
+static bool
+fpu_signal_include(const xsave_proc_info_t *infop, uint64_t xs_bv)
+{
+	return ((infop->xi_bits & xs_bv) == infop->xi_bits &&
+	    infop->xi_signal_out != NULL);
+}
+
+/*
+ * We need to fill out the xsave related data into the ucontext_t that we've
+ * been given. We should have a valid user pointer at this point in the uc_xsave
+ * member. This is much simpler than the copyin that we have. Here are the
+ * current assumptions:
+ *
+ *   o This is being called for the current thread. This is not meant to operate
+ *     on an arbitrary thread's state.
+ *   o We cannot assume whether the FPU is valid in the pcb or not. While most
+ *     callers will have just called getfpregs() which saved the state, don't
+ *     assume that.
+ *   o We assume that the user address has the requisite required space for this
+ *     to be copied out.
+ *   o We assume that copyfunc() will ensure we are not copying into a kernel
+ *     address.
+ *
+ * For more information on the format of the data, see the 'Signal Handling and
+ * the ucontext_t' portion of the big theory statement. We copy out all the
+ * constituent parts and then come back and write out the actual final header
+ * information.
+ */
+int
+fpu_signal_copyout(struct _klwp *lwp, uintptr_t uaddr, fpu_copyout_f copyfunc)
+{
+	struct fpu_ctx *fpu = &lwp->lwp_pcb.pcb_fpu;
+	uint64_t xs_bv;
+	uc_xsave_t ucx;
+	int ret;
+
+	VERIFY3P(curthread, ==, lwptot(lwp));
+	VERIFY0(lwptot(lwp)->t_flag & T_KFPU);
+	ASSERT3U(fpu->fpu_flags & FPU_EN, ==, FPU_EN);
+
+	if (!fpu_xsave_enabled()) {
+		return (ENOTSUP);
+	}
+
+	/*
+	 * Unlike when we're dealing with /proc, we can unconditionally call
+	 * fp_save() because this is always called in the context that the lwp
+	 * we're operating on is always the one on CPU (which is what fp_save()
+	 * asserts).
+	 */
+	fp_save(fpu);
+
+	bzero(&ucx, sizeof (ucx));
+	ucx.ucx_vers = UC_XSAVE_VERS;
+	ucx.ucx_len += sizeof (uc_xsave_t);
+
+	xs_bv = fpu->fpu_regs.kfpu_u.kfpu_xs->xs_header.xsh_xstate_bv;
+	for (size_t i = 0; i < ARRAY_SIZE(fpu_xsave_info); i++) {
+		const xsave_proc_info_t *info = &fpu_xsave_info[i];
+
+		if (!fpu_signal_include(&fpu_xsave_info[i], xs_bv))
+			continue;
+		ret = info->xi_signal_out(info, copyfunc, &ucx,
+		    lwp->lwp_pcb.pcb_fpu.fpu_regs.kfpu_u.kfpu_generic,
+		    uaddr);
+		if (ret != 0) {
+			kpreempt_enable();
+			return (ret);
+		}
+	}
+
+	/*
+	 * Now that everything has been copied out, we should have an accurate
+	 * value in the uc_xsave_t header and we can copy that out at the start
+	 * of the user data.
+	 */
+	ret = copyfunc(&ucx, (void *)uaddr, sizeof (ucx));
+	return (ret);
+}
+
+/*
+ * Here we've been given a ucontext_t which potentially has a user pointer to
+ * xsave state that we've copied out previously. In this case we need to do the
+ * following, assuming UC_XSAVE is present:
+ *
+ *   o Copy in our header and validate it.
+ *   o Allocate an fpu context to use as a holding ground for all this data.
+ *   o If UC_FPU is set, override the xsave structure with the saved XMM state,
+ *     clear UC_FPU, and make sure that the correct xsave_bv bits are set.
+ *
+ * Currently we always allocate the additional state as a holding ground for the
+ * FPU. What we're copying in may not be valid and we don't want to clobber the
+ * existing FPU state or deal with merging it until we believe it's reasonable
+ * enough. The proc_t is here to set us up for when we have per-process settings
+ * in the extended feature disable MSRs.
+ */
+int
+fpu_signal_copyin(struct _klwp *lwp, ucontext_t *kuc)
+{
+	uc_xsave_t ucx;
+	uint64_t bv;
+	uintptr_t data, max_data;
+	void *fpu;
+	proc_t *p = lwp->lwp_procp;
+	size_t ksize;
+
+	/*
+	 * Because this has been opaque filler and the kernel has never
+	 * historically looked at it, we don't really care about the uc_xsave
+	 * pointer being garbage in the case that the flag is not set. While
+	 * this isn't perhaps the most sporting choice in some cases, this is on
+	 * the other hand, pragmatic.
+	 */
+	if ((kuc->uc_flags & UC_XSAVE) != 0) {
+		if (kuc->uc_xsave == 0) {
+			return (EINVAL);
+		}
+
+		if (!fpu_xsave_enabled()) {
+			return (ENOTSUP);
+		}
+	} else {
+		return (0);
+	}
+
+	if (ddi_copyin((const void *)kuc->uc_xsave, &ucx, sizeof (ucx), 0) !=
+	    0) {
+		return (EFAULT);
+	}
+
+	ksize = cpuid_get_xsave_size();
+	if (ucx.ucx_vers != UC_XSAVE_VERS || ucx.ucx_len < sizeof (ucx) ||
+	    ucx.ucx_len > ksize ||
+	    (ucx.ucx_bv & ~xsave_bv_all) != 0 ||
+	    (uintptr_t)p->p_as->a_userlimit - ucx.ucx_len <
+	    (uintptr_t)kuc->uc_xsave) {
+		return (EINVAL);
+	}
+
+	/*
+	 * OK, our goal right now is to recreate a valid xsave_state structure
+	 * that we'll ultimately end up having to merge with our existing one in
+	 * the FPU save state. The reason we describe this as a merge is to help
+	 * future us when we want to retain supervisor state which will never be
+	 * part of userland signal state. The design of the userland signal
+	 * state is basically to compress it as much as we can. This is done for
+	 * two reasons:
+	 *
+	 *   1) We currently consider this a private interface.
+	 *   2) We really want to minimize the actual amount of stack space we
+	 *	use as much as possible. Most applications aren't using AVX-512
+	 *	right now, so doing our own compression style is worthwhile. If
+	 *	libc adopts AVX-512 routines, we may want to change this.
+	 *
+	 * On the allocation below, our assumption is that if a thread has taken
+	 * a signal, then it is likely to take a signal again in the future (or
+	 * be shortly headed to its demise). As such, when that happens we will
+	 * leave the allocated signal stack around for the process. Most
+	 * applications don't allow all threads to take signals, so this should
+	 * hopefully help amortize the cost of the allocation.
+	 */
+	max_data = (uintptr_t)kuc->uc_xsave + ucx.ucx_len;
+	data = (uintptr_t)kuc->uc_xsave + sizeof (ucx);
+	bv = ucx.ucx_bv;
+	if (lwp->lwp_pcb.pcb_fpu.fpu_signal == NULL) {
+		lwp->lwp_pcb.pcb_fpu.fpu_signal =
+		    kmem_cache_alloc(fpsave_cachep, KM_SLEEP);
+	}
+	fpu = lwp->lwp_pcb.pcb_fpu.fpu_signal;
+
+	/*
+	 * Unconditionally initialize the memory we get in here to ensure that
+	 * it is in a reasonable state for ourselves. This ensures that unused
+	 * regions are mostly left in their initial state (the main exception
+	 * here is the x87/XMM state, but that should be OK). We don't fill in
+	 * the initial xsave state as we expect that to happen as part of our
+	 * processing.
+	 */
+	bzero(fpu, ksize);
+
+	for (size_t i = 0; i < ARRAY_SIZE(fpu_xsave_info); i++) {
+		int ret;
+		const xsave_proc_info_t *info = &fpu_xsave_info[i];
+		if (!info->xi_always && (info->xi_bits & bv) == 0)
+			continue;
+		bv &= ~info->xi_bits;
+
+		if (info->xi_signal_in == NULL)
+			continue;
+		ret = info->xi_signal_in(info, kuc, &ucx, fpu, &data, max_data);
+		if (ret != 0) {
+			return (ret);
+		}
+	}
+	ASSERT0(bv);
+
+	/*
+	 * As described in the big theory statement section 'Signal Handling and
+	 * the ucontext_t', we always remove UC_FPU from here as we've taken
+	 * care of reassembling it ourselves.
+	 */
+	kuc->uc_flags &= ~UC_FPU;
+	kuc->uc_xsave = (uintptr_t)fpu;
+
+	return (0);
+}
+
+/*
+ * This determines the size of the signal stack that we need for our custom form
+ * of the xsave state.
+ */
+size_t
+fpu_signal_size(struct _klwp *lwp)
+{
+	struct fpu_ctx *fpu = &lwp->lwp_pcb.pcb_fpu;
+	size_t len = sizeof (uc_xsave_t);
+	uint64_t xs_bv;
+
+	VERIFY3P(curthread, ==, lwptot(lwp));
+	VERIFY0(lwptot(lwp)->t_flag & T_KFPU);
+	ASSERT3U(fpu->fpu_flags & FPU_EN, ==, FPU_EN);
+
+	if (!fpu_xsave_enabled()) {
+		return (0);
+	}
+
+	kpreempt_disable();
+	if ((fpu->fpu_flags & (FPU_EN | FPU_VALID)) == FPU_EN) {
+		fp_save(fpu);
+	}
+
+	xs_bv = fpu->fpu_regs.kfpu_u.kfpu_xs->xs_header.xsh_xstate_bv;
+	for (size_t i = 0; i < ARRAY_SIZE(fpu_xsave_info); i++) {
+		size_t comp_size;
+
+		if (!fpu_signal_include(&fpu_xsave_info[i], xs_bv))
+			continue;
+
+		cpuid_get_xsave_info(fpu_xsave_info[i].xi_bits, &comp_size,
+		    NULL);
+		len += comp_size;
+	}
+
+	kpreempt_enable();
+	return (len);
+}
+
+/*
+ * This function is used in service of restorecontext() to set the specified
+ * thread's extended FPU state to the passed in data. Our assumptions at this
+ * point from the system are:
+ *
+ *   o Someone has already verified that the actual xsave header is correct.
+ *   o Any traditional XMM state that causes a #gp has been clamped.
+ *   o That data is basically the correct sized xsave state structure. Right now
+ *     that means it is not compressed and follows the CPUID-based rules for
+ *     constructing and laying out data.
+ *   o That the lwp argument does refer to the current thread.
+ *
+ * Our primary purpose here is to merge the current FPU state with what exists
+ * here. Right now, "merge", strictly speaking is just "replace". We can get
+ * away with just replacing everything because all we currently save are user
+ * states. If we start saving kernel states in here, this will get more nuanced
+ * and we will need to be more careful about how we store data here.
+ */
+void
+fpu_set_xsave(struct _klwp *lwp, const void *data)
+{
+	struct fpu_ctx *fpu = &lwp->lwp_pcb.pcb_fpu;
+	uint32_t status, xstatus;
+	struct xsave_state *dst_xsave;
+
+	ASSERT(fpu_xsave_enabled());
+	VERIFY3P(curthread, ==, lwptot(lwp));
+	VERIFY0(lwptot(lwp)->t_flag & T_KFPU);
+	ASSERT3U(fpu->fpu_flags & FPU_EN, ==, FPU_EN);
+
+	/*
+	 * We use fp_save() here rather than a stock fpdisable() so we can
+	 * attempt to honor our invariants that when the thread state has been
+	 * saved, the valid flag is set, even though we're going to be
+	 * overwriting it shortly. If we just called fpdisable() then we would
+	 * basically be asking for trouble.
+	 *
+	 * Because we are modifying the state here and we don't want the system
+	 * to end up in an odd state, we are being a little paranoid and
+	 * disabling preemption across this operation. In particular, once the
+	 * state is properly tagged with FPU_VALID, there should be no other way
+	 * that this thread can return to userland and get cleared out because
+	 * we're resetting its context; however, we let paranoia win out.
+	 */
+	kpreempt_disable();
+	if ((fpu->fpu_flags & (FPU_EN | FPU_VALID)) == FPU_EN) {
+		fp_save(fpu);
+	}
+
+	bcopy(data, lwp->lwp_pcb.pcb_fpu.fpu_regs.kfpu_u.kfpu_generic,
+	    cpuid_get_xsave_size());
+	dst_xsave = lwp->lwp_pcb.pcb_fpu.fpu_regs.kfpu_u.kfpu_generic;
+	status = dst_xsave->xs_fxsave.__fx_ign2[3]._l[0];
+	xstatus = dst_xsave->xs_fxsave.__fx_ign2[3]._l[1];
+	dst_xsave->xs_fxsave.__fx_ign2[3]._l[0] = 0;
+	dst_xsave->xs_fxsave.__fx_ign2[3]._l[1] = 0;
+
+	/*
+	 * These two status words are information that the kernel itself uses to
+	 * track additional information and is part of the traditional fpregset,
+	 * but is not part of our xregs information. Because we are setting this
+	 * state, we leave it up to the rest of the kernel to determine whether
+	 * this came from an fpregset_t or is being reset to the default of 0.
+	 */
+	fpu->fpu_regs.kfpu_status = status;
+	fpu->fpu_regs.kfpu_xstatus = xstatus;
+
+	fpu->fpu_flags |= FPU_VALID;
+	PCB_SET_UPDATE_FPU(&lwp->lwp_pcb);
+	kpreempt_enable();
+}
+
+/*
+ * Convert the current FPU state to the traditional fpregset_t. In the 64-bit
+ * kernel, this is just an fxsave_state with additional values for the status
+ * and xstatus members.
+ *
+ * This has the same nuance as the xregs cases discussed above, but is simpler
+ * in that we only need to handle the fxsave state, but more complicated because
+ * we need to check our save mechanism.
+ */
+void
+fpu_get_fpregset(struct _klwp *lwp, fpregset_t *fp)
+{
+	struct fpu_ctx *fpu = &lwp->lwp_pcb.pcb_fpu;
+
+	kpreempt_disable();
+	fp->fp_reg_set.fpchip_state.status = fpu->fpu_regs.kfpu_status;
+	fp->fp_reg_set.fpchip_state.xstatus = fpu->fpu_regs.kfpu_xstatus;
+
+	if ((fpu->fpu_flags & (FPU_EN | FPU_VALID)) == FPU_EN) {
+		/*
+		 * If we're requesting the fpregs of a thread that isn't
+		 * currently valid and isn't the one that we're executing, then
+		 * we consider getting this information to be a best-effort and
+		 * we will not stop the thread in question to serialize it,
+		 * which means possibly getting stale data. This is the
+		 * traditional semantics that the system has used to service
+		 * this for /proc.
+		 */
+		if (curthread == lwptot(lwp)) {
+			VERIFY0(lwptot(lwp)->t_flag & T_KFPU);
+			fp_save(fpu);
+		}
+	}
+
+	/*
+	 * If the FPU is not enabled and the state isn't valid (due to someone
+	 * else setting it), just copy the initial state.
+	 */
+	if ((fpu->fpu_flags & (FPU_EN | FPU_VALID)) == 0) {
+		bcopy(&sse_initial, fp, sizeof (sse_initial));
+		kpreempt_enable();
+		return;
+	}
+
+	/*
+	 * Given that we have an enabled FPU, we must look at the type of FPU
+	 * save mechanism to clean this up. In particular, while we can just
+	 * copy the save area with FXSAVE, with XSAVE we must carefully copy
+	 * only the bits that are valid and reset the rest to their default
+	 * state.
+	 */
+	switch (fp_save_mech) {
+	case FP_FXSAVE:
+		bcopy(fpu->fpu_regs.kfpu_u.kfpu_fx, fp,
+		    sizeof (struct fxsave_state));
+		break;
+	case FP_XSAVE:
+		fpu_xsave_to_fxsave(fpu->fpu_regs.kfpu_u.kfpu_xs,
+		    (struct fxsave_state *)fp);
+		break;
+	default:
+		panic("Invalid fp_save_mech");
+	}
+
+	kpreempt_enable();
+}
+
+/*
+ * This is a request to set the ABI fpregset_t into our actual hardware state.
+ * In the 64-bit kernel the first 512 bytes of the fpregset_t is the same as the
+ * 512-byte fxsave area.
+ */
+void
+fpu_set_fpregset(struct _klwp *lwp, const fpregset_t *fp)
+{
+	struct fpu_ctx *fpu = &lwp->lwp_pcb.pcb_fpu;
+
+	kpreempt_disable();
+	if ((fpu->fpu_flags & (FPU_EN | FPU_VALID)) == FPU_EN) {
+		/*
+		 * We always save the entire FPU. This is required if we're
+		 * using xsave. If we're using fxsave, we could skip the
+		 * 512-byte write and instead just disable the FPU since we'd be
+		 * replacing it all. For now we don't bother with more
+		 * conditional logic.
+		 */
+		VERIFY3P(curthread, ==, lwptot(lwp));
+		VERIFY0(lwptot(lwp)->t_flag & T_KFPU);
+		fp_save(fpu);
+	}
+
+	fpu->fpu_regs.kfpu_xstatus = fp->fp_reg_set.fpchip_state.xstatus;
+	fpu->fpu_regs.kfpu_status = fp->fp_reg_set.fpchip_state.status;
+	switch (fp_save_mech) {
+	case FP_FXSAVE:
+		bcopy(fp, fpu->fpu_regs.kfpu_u.kfpu_fx,
+		    sizeof (struct fxsave_state));
+		break;
+	case FP_XSAVE:
+		bcopy(fp, fpu->fpu_regs.kfpu_u.kfpu_xs,
+		    sizeof (struct fxsave_state));
+		fpu->fpu_regs.kfpu_u.kfpu_xs->xs_header.xsh_xstate_bv |=
+		    XFEATURE_LEGACY_FP | XFEATURE_SSE;
+		break;
+	default:
+		panic("Invalid fp_save_mech");
+	}
+
+	fpu->fpu_flags |= FPU_VALID;
+	PCB_SET_UPDATE_FPU(&lwp->lwp_pcb);
+	kpreempt_enable();
 }
